osgDB::BaseSerializer Class Referenceabstract

`#include <Serializer>`

Inheritance diagram for osgDB::BaseSerializer:

## Public Types

enum

Type {
RW_UNDEFINED = 0 , RW_USER , RW_OBJECT , RW_IMAGE ,
RW_LIST , RW_BOOL , RW_CHAR , RW_UCHAR ,
RW_SHORT , RW_USHORT , RW_INT , RW_UINT ,
RW_FLOAT , RW_DOUBLE , RW_VEC2F , RW_VEC2D ,
RW_VEC3F , RW_VEC3D , RW_VEC4F , RW_VEC4D ,
RW_QUAT , RW_PLANE , RW_MATRIXF , RW_MATRIXD ,
RW_MATRIX , RW_GLENUM , RW_STRING , RW_ENUM ,
RW_VEC2B , RW_VEC2UB , RW_VEC2S , RW_VEC2US ,
RW_VEC2I , RW_VEC2UI , RW_VEC3B , RW_VEC3UB ,
RW_VEC3S , RW_VEC3US , RW_VEC3I , RW_VEC3UI ,
RW_VEC4B , RW_VEC4UB , RW_VEC4S , RW_VEC4US ,
RW_VEC4I , RW_VEC4UI , RW_BOUNDINGBOXF , RW_BOUNDINGBOXD ,
RW_BOUNDINGSPHEREF , RW_BOUNDINGSPHERED , RW_VECTOR , RW_MAP
}

enum | Usage { READ_WRITE_PROPERTY = 1 , GET_PROPERTY = 2 , SET_PROPERTY = 4 , GET_SET_PROPERTY = GET_PROPERTY | SET_PROPERTY }

## Public Member Functions

| BaseSerializer (int usage)
virtual bool | set (osg::Object &, void *)
virtual bool | get (const osg::Object &, void *)
virtual bool | read (InputStream &, osg::Object &)=0
virtual bool | write (OutputStream &, const osg::Object &)=0
virtual const std::string & | getName () const =0
virtual IntLookup * | getIntLookup ()
void | setUsage (int usage)
int | getUsage () const
void | setUsage (bool hasGetter, bool hasSetter)
bool | supportsReadWrite () const
bool | supportsGetSet () const
bool | supportsGet () const
bool | supportsSet () const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Attributes

int | _firstVersion
int | _lastVersion
int | _usage
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Friends

class | ObjectWrapper

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Member Enumeration Documentation

## Type

enum osgDB::BaseSerializer::Type

Enumerator
RW_UNDEFINED |
RW_USER |
RW_OBJECT |
RW_IMAGE |
RW_LIST |
RW_BOOL |
RW_CHAR |
RW_UCHAR |
RW_SHORT |
RW_USHORT |
RW_INT |
RW_UINT |
RW_FLOAT |
RW_DOUBLE |
RW_VEC2F |
RW_VEC2D |
RW_VEC3F |
RW_VEC3D |
RW_VEC4F |
RW_VEC4D |
RW_QUAT |
RW_PLANE |
RW_MATRIXF |
RW_MATRIXD |
RW_MATRIX |
RW_GLENUM |
RW_STRING |
RW_ENUM |
RW_VEC2B |
RW_VEC2UB |
RW_VEC2S |
RW_VEC2US |
RW_VEC2I |
RW_VEC2UI |
RW_VEC3B |
RW_VEC3UB |
RW_VEC3S |
RW_VEC3US |
RW_VEC3I |
RW_VEC3UI |
RW_VEC4B |
RW_VEC4UB |
RW_VEC4S |
RW_VEC4US |
RW_VEC4I |
RW_VEC4UI |
RW_BOUNDINGBOXF |
RW_BOUNDINGBOXD |
RW_BOUNDINGSPHEREF |
RW_BOUNDINGSPHERED |
RW_VECTOR |
RW_MAP |

## Usage

enum osgDB::BaseSerializer::Usage

Enumerator
READ_WRITE_PROPERTY |
GET_PROPERTY |
SET_PROPERTY |
GET_SET_PROPERTY |

## Constructor & Destructor Documentation

## BaseSerializer()

osgDB::BaseSerializer::BaseSerializer | ( | int | usage | ) |

inline

References _firstVersion, _lastVersion, and _usage.

Referenced by osgDB::ListSerializer< C, P >::ListSerializer(), osgDB::MapBaseSerializer::MapBaseSerializer(), osgDB::ObjectSerializer< C, P >::ObjectSerializer(), osgDB::TemplateSerializer< osg::Matrix >::TemplateSerializer(), osgDB::UserSerializer< C >::UserSerializer(), and osgDB::VectorBaseSerializer::VectorBaseSerializer().

## Member Function Documentation

## get()

virtual bool osgDB::BaseSerializer::get | ( | const osg::Object & | ,
|  | void * | )

inline virtual

Reimplemented in osgDB::ImageSerializer< C, P >, and osgDB::ObjectSerializer< C, P >.

## getIntLookup()

virtual IntLookup * osgDB::BaseSerializer::getIntLookup | ( |  | ) |

inline virtual

Reimplemented in osgDB::EnumSerializer< C, P, B >.

## getName()

virtual const std::string & osgDB::BaseSerializer::getName | ( |  | ) | const

pure virtual

Implemented in osgDB::IsAVectorSerializer< C >, osgDB::ListSerializer< C, P >, osgDB::MapSerializer< C, P >, osgDB::ObjectSerializer< C, P >, osgDB::TemplateSerializer< P >, osgDB::TemplateSerializer< osg::Matrix >, osgDB::TemplateSerializer< P * >, osgDB::TemplateSerializer< std::string >, osgDB::TemplateSerializer< unsigned int >, osgDB::UserSerializer< C >, and osgDB::VectorSerializer< C, P >.

## getUsage()

int osgDB::BaseSerializer::getUsage | ( |  | ) | const

inline

References _usage.

## read()

virtual bool osgDB::BaseSerializer::read | ( | InputStream & | ,
|  | osg::Object & | )

pure virtual

Implemented in osgDB::BitFlagsSerializer< C, P >, osgDB::EnumSerializer< C, P, B >, osgDB::GLenumSerializer< C, P >, osgDB::ImageSerializer< C, P >, osgDB::IsAVectorSerializer< C >, osgDB::ListSerializer< C, P >, osgDB::MapSerializer< C, P >, osgDB::MatrixSerializer< C >, osgDB::ObjectSerializer< C, P >, osgDB::PropByRefSerializer< C, P >, osgDB::PropByValSerializer< C, P >, osgDB::StringSerializer< C >, osgDB::TemplateSerializer< P >, osgDB::TemplateSerializer< osg::Matrix >, osgDB::TemplateSerializer< P * >, osgDB::TemplateSerializer< std::string >, osgDB::TemplateSerializer< unsigned int >, osgDB::UserSerializer< C >, and osgDB::VectorSerializer< C, P >.

## set()

virtual bool osgDB::BaseSerializer::set | ( | osg::Object & | ,
|  | void * | )

inline virtual

Reimplemented in osgDB::ImageSerializer< C, P >, and osgDB::ObjectSerializer< C, P >.

## setUsage() [1/2]

void osgDB::BaseSerializer::setUsage | ( | bool | hasGetter,
|  | bool | hasSetter )

inline

References GET_PROPERTY, READ_WRITE_PROPERTY, SET_PROPERTY, and setUsage().

## setUsage() [2/2]

void osgDB::BaseSerializer::setUsage | ( | int | usage | ) |

inline

References _usage.

Referenced by osgDB::EnumSerializer< C, P, B >::EnumSerializer(), osgDB::GLenumSerializer< C, P >::GLenumSerializer(), osgDB::ImageSerializer< C, P >::ImageSerializer(), osgDB::MatrixSerializer< C >::MatrixSerializer(), osgDB::ObjectSerializer< C, P >::ObjectSerializer(), osgDB::PropByRefSerializer< C, P >::PropByRefSerializer(), osgDB::PropByValSerializer< C, P >::PropByValSerializer(), setUsage(), and osgDB::StringSerializer< C >::StringSerializer().

## supportsGet()

bool osgDB::BaseSerializer::supportsGet | ( |  | ) | const

inline

References _usage, and GET_PROPERTY.

## supportsGetSet()

bool osgDB::BaseSerializer::supportsGetSet | ( |  | ) | const

inline

References _usage, and GET_SET_PROPERTY.

## supportsReadWrite()

bool osgDB::BaseSerializer::supportsReadWrite | ( |  | ) | const

inline

References _usage, and READ_WRITE_PROPERTY.

## supportsSet()

bool osgDB::BaseSerializer::supportsSet | ( |  | ) | const

inline

References _usage, and SET_PROPERTY.

## write()

virtual bool osgDB::BaseSerializer::write | ( | OutputStream & | ,
|  | const osg::Object & | )

pure virtual

Implemented in osgDB::BitFlagsSerializer< C, P >, osgDB::EnumSerializer< C, P, B >, osgDB::GLenumSerializer< C, P >, osgDB::ImageSerializer< C, P >, osgDB::IsAVectorSerializer< C >, osgDB::ListSerializer< C, P >, osgDB::MapSerializer< C, P >, osgDB::MatrixSerializer< C >, osgDB::ObjectSerializer< C, P >, osgDB::PropByRefSerializer< C, P >, osgDB::PropByValSerializer< C, P >, osgDB::StringSerializer< C >, osgDB::TemplateSerializer< P >, osgDB::TemplateSerializer< osg::Matrix >, osgDB::TemplateSerializer< P * >, osgDB::TemplateSerializer< std::string >, osgDB::TemplateSerializer< unsigned int >, osgDB::UserSerializer< C >, and osgDB::VectorSerializer< C, P >.

## Friends And Related Symbol Documentation

## ObjectWrapper

friend class ObjectWrapper

friend

References ObjectWrapper.

Referenced by ObjectWrapper.

## Member Data Documentation

## _firstVersion

int osgDB::BaseSerializer::_firstVersion

protected

Referenced by BaseSerializer().

## _lastVersion

int osgDB::BaseSerializer::_lastVersion

protected

Referenced by BaseSerializer().

## _usage

int osgDB::BaseSerializer::_usage

protected

Referenced by BaseSerializer(), getUsage(), setUsage(), supportsGet(), supportsGetSet(), supportsReadWrite(), and supportsSet().

The documentation for this class was generated from the following file:

- Serializer